<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: /home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/sdio_bt_a.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/sdio_bt_a.h</h1><div class="fragment"><pre>00001 <span class="comment">/*</span>
00002 <span class="comment"> * SDIO Bluetooth Type-A interface definitions.</span>
00003 <span class="comment"> *</span>
00004 <span class="comment"> * Copyright (C) 2007 Cambridge Silicon Radio Ltd.</span>
00005 <span class="comment"> *</span>
00006 <span class="comment"> * Refer to LICENSE.txt included with this source code for details on</span>
00007 <span class="comment"> * the license terms.</span>
00008 <span class="comment"> */</span>
00009 <span class="preprocessor">#ifndef SDIOEMB_SDIO_BT_A_H</span>
00010 <span class="preprocessor"></span><span class="preprocessor">#define SDIOEMB_SDIO_BT_A_H</span>
00011 <span class="preprocessor"></span>
00012 <span class="preprocessor">#include &lt;sdioemb/sdio_csr.h&gt;</span>
00013 
00014 <span class="comment">/*</span>
00015 <span class="comment"> * Standard SDIO function registers for a Bluetooth Type-A interface.</span>
00016 <span class="comment"> */</span>
00017 <span class="preprocessor">#define SDIO_BT_A_RD 0x00</span>
00018 <span class="preprocessor"></span><span class="preprocessor">#define SDIO_BT_A_TD 0x00</span>
00019 <span class="preprocessor"></span>
00020 <span class="preprocessor">#define SDIO_BT_A_RX_PKT_CTRL 0x10</span>
00021 <span class="preprocessor"></span><span class="preprocessor">#  define PC_RRT 0x01</span>
00022 <span class="preprocessor"></span>
00023 <span class="preprocessor">#define SDIO_BT_A_TX_PKT_CTRL 0x11</span>
00024 <span class="preprocessor"></span><span class="preprocessor">#  define PC_WRT 0x01</span>
00025 <span class="preprocessor"></span>
00026 <span class="preprocessor">#define SDIO_BT_A_RETRY_CTRL  0x12</span>
00027 <span class="preprocessor"></span><span class="preprocessor">#  define RTC_STAT 0x01</span>
00028 <span class="preprocessor"></span><span class="preprocessor">#  define RTC_SET  0x01</span>
00029 <span class="preprocessor"></span>
00030 <span class="preprocessor">#define SDIO_BT_A_INTRD       0x13</span>
00031 <span class="preprocessor"></span><span class="preprocessor">#  define INTRD 0x01</span>
00032 <span class="preprocessor"></span><span class="preprocessor">#  define CL_INTRD 0x01</span>
00033 <span class="preprocessor"></span>
00034 <span class="preprocessor">#define SDIO_BT_A_INT_EN      0x14</span>
00035 <span class="preprocessor"></span><span class="preprocessor">#  define EN_INTRD 0x01</span>
00036 <span class="preprocessor"></span>
00037 <span class="preprocessor">#define SDIO_BT_A_BT_MODE     0x20</span>
00038 <span class="preprocessor"></span><span class="preprocessor">#  define MD_STAT 0x01</span>
00039 <span class="preprocessor"></span>
00040 <span class="comment">/*</span>
00041 <span class="comment"> * Length of the Type-A header.</span>
00042 <span class="comment"> *</span>
00043 <span class="comment"> * Packet length (3 octets) plus Service ID (1 octet).</span>
00044 <span class="comment"> */</span>
00045 <span class="preprocessor">#define SDIO_BT_A_HEADER_LEN 4</span>
00046 <span class="preprocessor"></span>
00047 <span class="comment">/*</span>
00048 <span class="comment"> * Maximum length of a Type-A transport packet.</span>
00049 <span class="comment"> *</span>
00050 <span class="comment"> * Type-A header length and maximum length of a HCI packet (65535</span>
00051 <span class="comment"> * octets).</span>
00052 <span class="comment"> */</span>
00053 <span class="preprocessor">#define SDIO_BT_A_PACKET_LEN_MAX 65543</span>
00054 <span class="preprocessor"></span>
00055 <span class="keyword">enum</span> sdio_bt_a_service_id {
00056     SDIO_BT_A_SID_CMD    = 0x01,
00057     SDIO_BT_A_SID_ACL    = 0x02,
00058     SDIO_BT_A_SID_SCO    = 0x03,
00059     SDIO_BT_A_SID_EVT    = 0x04,
00060     SDIO_BT_A_SID_VENDOR = 0xfe,
00061 };
00062 
00063 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">int</span> sdio_bt_a_packet_len(<span class="keyword">const</span> <span class="keywordtype">char</span> *p)
00064 {
00065     <span class="keywordflow">return</span> (p[0] &amp; 0xff) | ((p[1] &amp; 0xff) &lt;&lt; 8) | ((p[2] &amp; 0xff) &lt;&lt; 16);
00066 }
00067 
00068 <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">int</span> sdio_bt_a_service_id(<span class="keyword">const</span> <span class="keywordtype">char</span> *p)
00069 {
00070     <span class="keywordflow">return</span> p[3];
00071 }
00072 
00073 <span class="keyword">struct </span>sdio_bt_a_pkt_info {
00074     <span class="keywordtype">void</span> *  data;
00075     <span class="keywordtype">int</span>     data_len; <span class="comment">/* excluding Type-A header */</span>
00076     uint8_t hdr[SDIO_BT_A_HEADER_LEN];
00077     uint8_t tx_data[0];
00078 };
00079 
00080 <span class="comment">/*</span>
00081 <span class="comment"> * Minimum amount to read (excluding the Type-A header). This allows</span>
00082 <span class="comment"> * short packets (e.g., flow control packets) to be read with a single</span>
00083 <span class="comment"> * command.</span>
00084 <span class="comment"> */</span>
00085 <span class="preprocessor">#define SDIO_BT_A_MIN_READ (32 - SDIO_BT_A_HEADER_LEN)</span>
00086 <span class="preprocessor"></span>
00087 <span class="preprocessor">#define SDIO_BT_A_NAME_LEN 16</span>
00088 <span class="preprocessor"></span>
00089 <span class="keyword">struct </span>sdio_bt_a_dev {
00090     <span class="keyword">struct </span><a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev;
00091     <span class="keywordtype">char</span> name[SDIO_BT_A_NAME_LEN];
00092     <span class="keywordtype">void</span> *drv_data;
00093 
00094     void (*receive)(<span class="keyword">struct </span>sdio_bt_a_dev *bt, <span class="keyword">struct </span>sdio_bt_a_pkt_info *pkt);
00095     void (*sleep_state_changed)(<span class="keyword">struct </span>sdio_bt_a_dev *bt);
00096 
00097     <span class="keyword">enum</span> <a class="code" href="group__registers.html#ga11">sdio_sleep_state</a> sleep_state;
00098 
00099     uint8_t  max_tx_retries;
00100     uint8_t  max_rx_retries;
00101     <span class="keywordtype">unsigned</span> needs_read_ack:1;
00102     <span class="keywordtype">unsigned</span> wait_for_firmware:1;
00103 };
00104 
00105 <span class="keywordtype">void</span> sdio_bt_a_init(<span class="keyword">struct</span> sdio_bt_a_dev *bt, <span class="keyword">struct</span> <a class="code" href="structsdio__dev.html">sdio_dev</a> *fdev);
00106 <span class="keywordtype">int</span>  sdio_bt_a_send(<span class="keyword">struct</span> sdio_bt_a_dev *bt, <span class="keyword">const</span> <span class="keyword">struct</span> sdio_bt_a_pkt_info *pkt);
00107 <span class="keywordtype">void</span> sdio_bt_a_handle_interrupt(<span class="keyword">struct</span> sdio_bt_a_dev *bt);
00108 <span class="keywordtype">void</span> sdio_bt_a_set_sleep_state(<span class="keyword">struct</span> sdio_bt_a_dev *bt, <span class="keyword">enum</span> sdio_sleep_state state);
00109 <span class="keywordtype">int</span>  sdio_bt_a_check_for_reset(<span class="keyword">struct</span> sdio_bt_a_dev *bt);
00110 <span class="keywordtype">void</span> sdio_bt_a_start(<span class="keyword">struct</span> sdio_bt_a_dev *bt);
00111 <span class="keywordtype">void</span> sdio_bt_a_stop(<span class="keyword">struct</span> sdio_bt_a_dev *bt);
00112 
00113 <span class="preprocessor">#endif </span><span class="comment">/* #ifndef SDIOEMB_SDIO_BT_A_H */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
